# Library Compilation
Copy the files to your QuickAI SDK directory. A script is provided to do this for you in the knowledgepack folder:

`copy_files.sh <path_to_quickAI_sdk_root>`

To build:

```Language=bash
cd <path_to_quickAI_sdk_root>/App/knowledgepack_project/GCC_Project
make
```

Hex file will be located in output/bin from the GCC_Project directory.

# Binary File Flashing
## QuickAI S3 (Merced and Chilkat)

### Flash Tool Download
You can find the latest flash tool [from QuickLogic](http://quickai.quicklogic.com/) Unzip the download to a folder and then open a command line window in the newly created folder.

Example: `C:\downloads\QlFlashImage_Release_v1.3\images\mercedproto_ai_app_recog\IAR`

### Flashing the Board
Be sure to have your QuickAI board plugged in, so that you can find the right COM port to flash with.

1. Copy the binary file from this download to the Flash Tool folder above
2. Rename the Knowledge Pack binary to `mercedproto_ai_app_recog.bin`

**OR**

1. In the `flash_all_iar.json` file, find the Tag `MCU_M4.bin`
2. Rename the `Input` to your downloaded Knowledge Pack file name.


From the command line, run the following command, replacing `COM_PORT` with the proper port from your machine, then reboot your QuickAI board:

`flash_via_uart_iar.bat COM_PORT`

## QuickAI BLE

The BLE application that comes with your download is only necessary to flash if you have a different version. the binary will be ble_app_quickAI_version_(number).hex. This generally does not change.If you notice simple communication with BLE isn't returning the same information as before, it's a good idea to flash this.

The current ble app version is:

5

You can use [NRFGo Studio from Nordic](https://www.nordicsemi.com/eng/Products/2.4GHz-RF/nRFgo-Studio) to do this. Simply use the nrf5xx Programming -> Application tab.

## Model.json File
The model.json file gives a description of the model(s) in your Knowledge Pack. The Windows TestApp can load this file for visualization of model results. The main section for visualization for your use is the ClassMap.